package cn.ibizlab.codegen.cmd;

import cn.ibizlab.codegen.templating.TemplateManager;
import io.airlift.airline.Command;
import io.airlift.airline.Option;
import org.springframework.core.io.Resource;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.core.io.support.ResourcePatternResolver;
import org.springframework.util.StringUtils;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

@SuppressWarnings({"unused", "java:S106"})
@Command(name = "ls", description = "Show list information used in tooling")
public class ListCommand extends IbizLabGeneratorCommand {

    @Option(name = {"-n","--template-name"}, description = "sepc template list")
    private String template;

    @Option(name = {"-a","--all"}, description = "template list")
    private Boolean all;

    @Override
    public void execute() {
        List<String> retList = new ArrayList<>();

        if (!StringUtils.isEmpty(template)) {
            getList("templ/"+template,"",retList,true);
        } else {
            getList("templ","",retList,false);
        }

        retList.forEach(item->System.out.println(item));
    }

    private ResourcePatternResolver resourceResolver = new PathMatchingResourcePatternResolver();


    public void getList(String rootDir,String templateDir, List<String> list,boolean recu)  {
        try
        {
            if(templateDir.endsWith("//"))
                return;
            URL url = this.getClass().getClassLoader().getResource(rootDir+"/"+templateDir);
            if (url != null) {
                InputStream stream = this.getClass().getClassLoader().getResourceAsStream(rootDir+"/"+templateDir);
                try(Scanner scanner = new Scanner(stream)) {
                    while (scanner.hasNextLine()) {
                        String str = scanner.nextLine();
                        if(!StringUtils.isEmpty(str))
                        {
                            String newPath=str;
                            if(!StringUtils.isEmpty(templateDir))
                                newPath=templateDir+"/"+str;

                            if(recu&&(!str.endsWith(".hbs"))&&(!str.endsWith(".ibizlab-generator-ignore"))&&(str.indexOf(".")<0))
                                getList(rootDir,newPath,list,recu);
                            else
                                list.add(newPath);
                        }
                    }
                } catch (Exception e) {
                }
            }



        }catch (Exception ex){
            ex.printStackTrace();
        }

    }

}
